%%%% combines BOLD regressor (seed time course) and physiological
%%%% regressors in different matlab files

%%%% BOLD regressor in first column, then motion - cardiac - respiratory
%%%% noise regressors (estimated with RETROICOR method).


tot_subj = 5;       % total number of subjects


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%% FOR SUBJECTS IN GROUP1 %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('Group 1...');

 for nsubj = 1:tot_subj  % iterates over subject name
        nsubj
        regressors = [];
        
        load_path = strcat('data/group1/subj',num2str(nsubj), '/BOLD_regressor.mat');  % creates string with path to BOLD regressor file
        load(load_path);
        
        load_path = strcat('data/group1/subj',num2str(nsubj), '/noise_regressors.mat');  % creates string with path to noise regressor file
        load(load_path);
        
        regressors(:,1) = timeseries;  % place BOLD regressors in the first column 
        dim=size(rp_save);
        regressors(:,2:dim(2) +1)  = rp_save; % place noise regressors in the other columns
        
        save_path = strcat('data/group1/subj',num2str(nsubj), '/all_regressors.txt');  % creates string with path to noise regressor file
        save(save_path, 'regressors', '-ascii');
    end
    
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%% FOR SUBJECTS IN GROUP2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('Group 2...');

    for nsubj = 1:tot_subj  % iterates over subject name
        nsubj
        regressors = [];
        
        load_path = strcat('data/group2/subj',num2str(nsubj), '/BOLD_regressor.mat');  % creates string with path to BOLD regressor file
        load(load_path);
        
        load_path = strcat('data/group2/subj',num2str(nsubj), '/noise_regressors.mat');  % creates string with path to noise regressor file
        load(load_path);
        
        regressors(:,1) = timeseries;  % place BOLD regressors in the first column 
        dim=size(rp_save);
        regressors(:,2:dim(2) +1)  = rp_save; % place noise regressors in the other columns
        
        save_path = strcat('data/group2/subj',num2str(nsubj), '/all_regressors.txt');  % creates string with path to noise regressor file
        save(save_path, 'regressors', '-ascii');
    end
    
