% script to extract a the BOLD timeseries from a region of interest (from AAL template) or MNI
% coordinates 
%clearvars -except aal
region = 78;        % AAL region to extract the BOLD regressor from
dim = size(aal);    % aal is the AAL template in the same resolution as the data
tot_vol = 50;       % total number of volumes
tot_subj = 5;       % total number of subjects

%seed_x= 46; seed_y=16; seed_z=28;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%% FOR SUBJECTS IN GROUP1 %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('Group 1...')

    for nsubj = 1:tot_subj  % iterates over subject name
        
        timeseries = [];
        
        for nimg = 1:tot_vol   % iterates over image volume
        [nsubj, nimg]
        load_path = strcat('data/group1/subj',num2str(nsubj), '/', num2str(nimg), '.img');  % creates string with path to image
        Y = spm_vol(load_path); data=spm_read_vols(Y);  % loads functional volume
        
        temp = 0; n=0;
        
        
%         %%%%%%%%%%%%%%%%%%%%% for AAL %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%         
        % iterates over the AAL template to average the image over the
        % specified region
        
        for x1=1:dim(1);
            for x2=1:dim(2);
                for x3=1:dim(3);
                    
                    if aal(x1,x2,x3) ==  region
                        temp=temp+data(x1,x2,x3); n=n+1;
                    end
                end
            end
        end
        
        timeseries(nimg) = temp/n; timeseries=timeseries';
%         
%         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%         
        %%%%%%%%%%% for seed       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
 %       timeseries(nimg) = data(seed_x, seed_y, seed_z) ;
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        end
        
        % save the timeseries (BOLD regressor) in the subject folder
        
        save_path = strcat('data/group1/subj',num2str(nsubj), '/BOLD_regressor.mat');  % creates string with path to BOLD regressor;
        save(save_path, 'timeseries');
    end
        
        
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%% FOR SUBJECTS IN GROUP2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('Group 2...')

    for nsubj = 1:tot_subj  % iterates over subject name
        
        timeseries = [];
        
        for nimg = 1:tot_vol   % iterates over image volume
        [nsubj, nimg]
        load_path = strcat('data/group2/subj',num2str(nsubj), '/', num2str(nimg), '.img');  % creates string with path to image
        Y = spm_vol(load_path); data=spm_read_vols(Y);  % loads functional volume
        
        temp = 0; n=0;
        
        
        %%%%%%%%%%%%%%%%%%%%%% for AAL %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        % iterates over the AAL template to average the image over the
        % specified region
        
        for x1=1:dim(1);
            for x2=1:dim(2);
                for x3=1:dim(3);
                    
                    if aal(x1,x2,x3) ==  region
                        temp=temp+data(x1,x2,x3); n=n+1;
                    end
                end
            end
        end
        
        timeseries(nimg) = temp/n; timeseries=timeseries';
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
               
        %%%%%%%%%%% for seed %%%%%%%%%%
        
        % timeseries(nimg) = data(seed_x, seed_y, seed_z) ;
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        end
        
        % save the timeseries (BOLD regressor) in the subject folder
        
        save_path = strcat('data/group2/subj',num2str(nsubj), '/BOLD_regressor.mat');  % creates string with path to BOLD regressor;
        save(save_path, 'timeseries');
    end
        
%           
% 
%         
%                 
%         
%         
%         
%         
% 
% 
% 
% 
% 
