% second level network analysis

% loads results produced in the first level and obtains statistics

groups = {'group1','group2'};
subjects= {'subj1','subj2','subj3','subj4','subj5'};
n_vols = 50;
dim = size(aal);


for ngroups = 1:length(groups)
    n=0;
    for nsubjects = 1:length(subjects)
        n=n+1;
        group = groups{ngroups};
        subject = subjects{nsubjects};
        
        load_path = strcat('data/', group, '/', subject, '/network_analysis');
        load(load_path);
        
        if group=='group1'
            c_group1(n,:) = c; c_rand_group1(n,:) = c_rand;
            l_group1(n,:) = l; l_rand_group1(n,:) = l_rand;
            e_group1(n,:) = e; e_rand_group1(n,:) = e_rand;
            Q_group1(n,:) = Q; Q_rand_group1(n,:) = Q_rands;
            Ci_group1(n,:,:) = Ci; Ci_rand_group1(n,:,:) = Ci_rand;
            degree_group1(n,:,:) = degree; degree_rand_group1(n,:,:) = degree_rand;
            bet_group1(n,:,:) = bet; bet_rand_group1(n,:,:) = bet_rand;
           
        end
        
        if group=='group2'
            c_group2(n,:) = c; c_rand_group2(n,:) = c_rand;
            l_group2(n,:) = l; l_rand_group2(n,:) = l_rand;
            e_group2(n,:) = e; e_rand_group2(n,:) = e_rand;
            Q_group2(n,:) = Q; Q_rand_group2(n,:) = Q_rands;
            Ci_group2(n,:,:) = Ci; Ci_rand_group2(n,:,:) = Ci_rand;
            degree_group2(n,:,:) = degree; degree_rand_group2(n,:,:) = degree_rand;
            bet_group2(n,:,:) =bet; bet_rand_group2(n,:,:) = bet_rand;
           
        end
        
    end
    
end

% conduct statistics

%%%%%%% group1 %%%%%%%%%%%

len = length(c);
for t=1:len
    
    mean_c_group1(t) = mean(c_group1(:,t) ); std_c_group1(t) = std(c_group1(:,t))/sqrt(length(subjects));
    mean_l_group1(t) = mean(l_group1(:,t) ); std_l_group1(t) = std(l_group1(:,t))/sqrt(length(subjects));
    mean_e_group1(t) = mean(e_group1(:,t) ); std_e_group1(t) = std(e_group1(:,t))/sqrt(length(subjects));
    mean_Q_group1(t) = mean(Q_group1(:,t) ); std_Q_group1(t) = std(Q_group1(:,t))/sqrt(length(subjects));
    
    for node = 1:90
    
    a = reshape(degree_group1(:,node,len), 1, length(subjects) ); mean_degree_group1(node,len) = mean(a); std_degree_group1(node,len) = std(a)/sqrt(length(subjects));
    a = reshape(bet_group1(:,node,len), 1, length(subjects) ); mean_bet_group1(node,len) = mean(a); std_bet_group1(node,len) = std(a)/sqrt(length(subjects));
    end
end

%%%%%%% group2 %%%%%%%%%%%

len = length(c);
for t=1:len
    
    
    mean_c_group2(t) = mean(c_group2(:,t) ); std_c_group2(t) = std(c_group2(:,t))/sqrt(length(subjects));
    mean_l_group2(t) = mean(l_group2(:,t) ); std_l_group2(t) = std(l_group2(:,t))/sqrt(length(subjects));
    mean_e_group2(t) = mean(e_group2(:,t) ); std_e_group2(t) = std(e_group2(:,t))/sqrt(length(subjects));
    mean_Q_group2(t) = mean(Q_group2(:,t) ); std_Q_group2(t) = std(Q_group2(:,t))/sqrt(length(subjects));
    
    for node = 1:90
    
    a = reshape(degree_group2(:,node,t), 1, length(subjects) ); mean_degree_group2(node,t) = mean(a); std_degree_group2(node,t) = std(a)/sqrt(length(subjects));
    a = reshape(bet_group2(:,node,t), 1, length(subjects) ); mean_bet_group2(node,t) = mean(a); std_bet_group2(node,t) = std(a)/sqrt(length(subjects));
    end
end

%%% comparison %%%%



for t= 1:len

a = c_group1(:,t); b = c_group2(:,t); [h,p] = ttest2(a,b); p_c(t) = p;
a = l_group1(:,t); b = l_group2(:,t); [h,p] = ttest2(a,b); p_l(t) = p;
a = e_group1(:,t); b = e_group2(:,t); [h,p] = ttest2(a,b); p_e(t) = p;
a = Q_group1(:,t); b = Q_group2(:,t); [h,p] = ttest2(a,b); p_Q(t) = p;

    
        for node=1:90
            
            a = reshape( degree_group1(:,node,t), 1, length(subjects) ) ;
            b = reshape( degree_group2(:,node,t), 1, length(subjects) ) ;
            [h,p] = ttest2(a,b); p_degree(node,t) = p;
            
            a = reshape( bet_group1(:,node,t), 1, length(subjects) ) ;
            b = reshape( bet_group2(:,node,t), 1, length(subjects) ) ;
            [h,p] = ttest2(a,b); p_bet(node,t) = p;
            
        end
        
    end
            
            
   thr = 0.01:0.02:0.5;
   
   
   figure
   subplot(2,2,1); hold on;
   errorbar(thr, mean_c_group1, std_c_group1, '-b', 'Linewidth', 2);
   errorbar(thr, mean_c_group2, std_c_group2, '-r', 'Linewidth', 2);
    title('Clustering coefficient, group 1 vs group 2')
    xlabel('Link density')
    ylabel('Clustering coefficient')

          subplot(2,2,2); hold on;
   errorbar(thr, mean_l_group1, std_l_group1, '-b', 'Linewidth', 2);
   errorbar(thr, mean_l_group2, std_l_group2, '-r', 'Linewidth', 2);
    title('Average path length, group 1 vs group 2')
    xlabel('Link density')
    ylabel('Average path length')    
    
            subplot(2,2,3); hold on;
   errorbar(thr, mean_e_group1, std_e_group1, '-b', 'Linewidth', 2);
   errorbar(thr, mean_e_group2, std_e_group2, '-r', 'Linewidth', 2);
    title('Efficiency, group 1 vs group 2')
    xlabel('Link density')
    ylabel('Efficiency')    
    
    
             subplot(2,2,4); hold on;
   errorbar(thr, mean_Q_group1, std_Q_group1, '-b', 'Linewidth', 2);
   errorbar(thr, mean_Q_group2, std_Q_group2, '-r', 'Linewidth', 2);
    title('Modularity, group 1 vs group 2')
    xlabel('Link density')
    ylabel('Modularity')   
    
    figure
          subplot(2,2,1); hold on;
 pcolor(mean_degree_group1 - mean_degree_group2)
    title('Degree difference, group1 - group2')
    xlabel('Link density')
    ylabel('AAL Region')   
    colorbar
    
    
          subplot(2,2,2); hold on;
 pcolor(double(p_degree<0.05/90))
    title('Significant differences in degree, p<0.05 (Bonferroni)')
    xlabel('Link density')
    ylabel('AAL Region')   
    
    
        
          subplot(2,2,3); hold on;
 pcolor(mean_bet_group1 - mean_bet_group2)
    title('Betweeness difference, group1 - group2')
    xlabel('Link density')
    ylabel('AAL Region')   
    colorbar
    
    
          subplot(2,2,4); hold on;
 pcolor(double(p_bet<0.05/90))
    title('Significant differences in betweeness, p<0.05 (Bonferroni)')
    xlabel('Link density')
    ylabel('AAL Region')   
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
            

            
            
            
            
















 

